{****************************************************************************}
{*                                                                          *}
{*                     UniPascal Demonstration Program.                     *}
{*      ஡  ६⢠  ᪠ 㫠          *}
{*               ணࠬ࠭  ࠭  ࣨ . ஢               *}
{*                       (c) 1989 George Petrov /YGP/                       *}
{*                                                                          *}
{****************************************************************************}

{****************************************************************************}
{*                                                                          *}
{*       ᪮    string    packed array  *}
{*     ⨣ -ﬠ ২   ᠭ  ᬥ⪠  ᬥ⪨.  *}
{*  ⢥  㤮⢮ ,  ᪮      ᪮   *}
{*        ᪠,   ﬠ   ਠ⭠  אַ ,  *}
{*       packed array of char.                               *}
{*     ࠭  (*$define Show *)     ꬠ  *}
{*   襭.                                                           *}
{*     ,          ,  ணࠬ ﬠ  *}
{*   ஬, ᢥ ࠬ  楤 MoveDisks (   *}
{*    ᫠   ᬥ⪠     ࠢ  室      *}
{*  㫠).  ⮢ ꬠ  ᢠ ࠪ᪨  4 .       *}
{*                                                                          *}
{****************************************************************************}

(*       ᪮ *)                {$define Show}
(*  ꤥ  梥⭮ *)                                        {$define color}
(*   ᢠ  ६    室 *)                 {$define info}
								      {$R-,I-}
program Han({$ifdef Show} message {$else} output {$endif});      {$ifdef Show}
  uses dos, UniCRT;                                  {$else} {$undef info} {$endif}

  label exit1, quit;

  const MaxStickSize = 19;   { ࠭ 80x25   ꤥ  19,  40x25  13 }
	msglimit=80;

{ ! }	x_delay=5;

  type Sticks = (StickA, StickB, StickC);
       NDisks = 0..MaxStickSize;

  var MoveCount: LongInt;                      {   ࠢ 室 }
      StickSize: NDisks;                 {   㫠  ᪠ }

								 {$ifdef Show}
  const Left    = '';                       { ᨬ   ࠩ  ᪠ }
	Middle  = '';                    { ᨬ  ।   ᪠ }
	right   = '';                      { ᨬ  ᭨ ࠩ  ᪠ }
	StickCh = '';                                       { ᨬ   }
	BaseCh  = '';                         { ᨬ  ᭮ () }

  type DiskString = string[MaxStickSize+1];
  ShortCard = byte;
  cardinal = word;

  var i:         Integer;                               { ࠡ⭠ ஬ }
      Start:     ShortCard;     { ।   碠 㢠  㫨 }
      Xoffset:   ShortCard;
      Disks:     array[Sticks] of NDisks;  {  ᪠   猪 窠 }
      EmptyDisk,                    { ।⠢ﭥ  ࠧ  ( ) }
      DiskPic:   DiskString;             { ।⠢ﭥ  类  ᪮ }

								{$ifdef color}
  const normal =  LightGray * 16 + Black;

  var DiskClr: packed array [1..MaxStickSize] of byte;                {$endif}

  procedure PrepDisk(N: NDisks);
    var Size: NDisks;
  begin                          { ⮢    ᢠ  ࠭ }
    {    ᪠     ⭮     ꫦ }
    {  - , ࠩ 樨  ।⠢  .       }
    Size:= N + ord(odd(StickSize) <> odd(N));
    DiskPic[0]:= chr(Size); FillChar(DiskPic[1], Size, Middle);
    if Size <> N then begin DiskPic[1]:= left; DiskPic[Size]:= right; end;
    EmptyDisk[0]:= chr(Size); FillChar(EmptyDisk[1], Size, ' ');
    if odd(Size) then EmptyDisk[(Size+1) div 2]:= StickCh;
  end { PrepDisk };
                                                                  {$ifdef info}
  var Hour, Min, Sec, s100: word;
      oldS, dH, dM, dS: integer;
      timeX, timeY: shortcard;

  procedure CalcTimeInterval;
    var nH, nM, nS, ns1: cardinal;
  begin { CalcTimeInterval }
    GetTime(nH, nM, nS, ns1);
    dS:= nS - Sec;
    while dS < 0 do begin
      inc(dS, 60);
      dec(nM);
    end { while };
    if oldS <> dS then begin
      dM:= nM - Min;
      while dM < 0 do begin
        inc(dM, 60); dec(nH);
      end { while };
      dH:= nH - Hour;
      while dH < 0 do begin
        inc(dH, 24);
      end { while };
      if keypressed and (readkey = #27) then halt
    end { if };
  end { CalcTimeInterval };                                  {$endif} {$endif}

  procedure MoveDisks(N: NDisks; Src, Dest, Work: Sticks);
                                                                 {$ifdef Show}
    procedure ShowMove(DiskSize: NDisks; Src, Dest: Sticks);
      var Xpos, Ypos, NewX, NewY: ShortCard;
          WorkDisk: DiskString;
    begin         { ࠬ ਤ     DiskSize  }
                                                                 {$ifdef info}
      GotoXY(   10, timeY); write(MoveCount);
      CalcTimeInterval;
      if oldS <> ds then begin
	GotoXY(timeX, timeY);
	write(dH div 10, dH mod 10, ':',
	      dM div 10, dM mod 10, ':',
	      dS div 10, dS mod 10);
	oldS:= dS;
      end { if };
								      {$endif}
      PrepDisk(DiskSize);                       { 窠 Src  窠 Dest. }
      Xpos:= Xoffset + ord(Src) * StickSize +1 + (StickSize - DiskSize) div 2;

      {      ᪠ ,  ᫥⥫ 㢠 ࠧ   }
      {    ,   ᠬ  㢠   । -.       }
      Ypos:= Start + StickSize - Disks[Src];
      repeat GotoXY(Xpos, Ypos); write(EmptyDisk);
	Dec(Ypos); GotoXY(Xpos, Ypos);
	{$ifdef Color} SetColor(DiskClr[DiskSize]); {$endif}
	write(DiskPic); delay(x_delay);
	{$ifdef Color} SetColor(Normal); {$endif}
      until Ypos = Start - 1;

      {   ਤ   ᭮  ᨬ  . }
      NewX:= Xoffset + ord(Dest) * StickSize +1 + (StickSize -DiskSize) div 2;
      WorkDisk:= DiskPic; WorkDisk[0]:= chr(length(WorkDisk) + 1);
      if NewX < Xpos then begin
	WorkDisk[length(WorkDisk)]:= ' ';                           {  }
	{$ifdef Color} SetColor(DiskClr[DiskSize]); {$endif}
	while Xpos <> NewX do begin
	  Dec(Xpos); GotoXY(Xpos, Ypos); write(WorkDisk);
	  delay(x_delay);
	end { while };
	{$ifdef Color} SetColor(Normal); {$endif} end
      else begin
	WorkDisk[1]:= ' ';                                         { ᭮ }
	Move(DiskPic[1], WorkDisk[2], length(DiskPic));
	{$ifdef Color} SetColor(DiskClr[DiskSize]); {$endif}
	while Xpos <> NewX do begin
	  GotoXY(Xpos, Ypos); write(WorkDisk); Inc(Xpos);
	  delay(x_delay);
	end { while };
	{$ifdef Color} SetColor(Normal); {$endif}
      end { if };

      dec(Disks[Src]);       {  Src 窠 ⠢   -, }
      inc(Disks[Dest]);             {   Dest     . }

      NewY:= Start + StickSize - Disks[Dest];    {   ਤ ᪠ }
      GotoXY(Xpos, Ypos); write(' ': StickSize); inc(Ypos);        { . }
      {$ifdef Color} SetColor(DiskClr[DiskSize]); {$endif}
      GotoXY(Xpos, Ypos); write(DiskPic);   { ⢨   筨  }
      {$ifdef Color} SetColor(Normal); {$endif}
      while Ypos <> NewY do begin   { ⥧  ਤ嬥 ᪠ . }
	GotoXY(Xpos, Ypos); write(EmptyDisk);
	{$ifdef Color} SetColor(DiskClr[DiskSize]); {$endif}
        inc(Ypos); GotoXY(Xpos, Ypos); write(DiskPic);
	{$ifdef Color} SetColor(Normal); {$endif}
      end { while };
    end { ShowMove };                                                 {$endif}

  begin { MoveDisks }
    if N = 0 then exit; {      0 ᪠ => ﬠ ࠡ }
    MoveDisks(N-1, Src, Work, Dest);  { ६⢠ N-1 ᪠  Src  Work }
    inc(MoveCount);                                             {$ifNdef Show}

    write(MoveCount: 7, ': ');           { ६⢠ 1   Src  Dest }
    if ord(Src) < ord(Dest)        {   ᢠ  ࠬ 室 }
      then write(chr(ord('A') +ord(Src)),  ' --> ', chr(ord('A') +ord(Dest)))
      else write(chr(ord('A') +ord(Dest)), ' <-- ', chr(ord('A') +ord(Src)));
    writeln;                                                           {$else}
    ShowMove(N, Src, Dest);   { ࠬ ६⢠  ᪠ }  {$endif}
    MoveDisks(N-1, Work, Dest, Src); { ६⢠ N-1 ᪠  Work  Dest }
  end { MoveDisks };

  procedure GetNdisks;
    var i: integer; s: string;

    procedure HelpUser;
    begin
      writeln(output, 'usage: HAN [N]');
      writeln(output, '  N is the number of disks and must be less than ',
		      succ(MaxStickSize));
      halt
    end; { HelpUser }

  begin { GetNdisks }
    if ParamCount = 1 then begin
      s:=ParamStr(1);  StickSize:= 0;
      for i:= 1 to length(s) do begin
	if s[i] in ['0'..'9']
          then StickSize:= StickSize * 10 + ord(s[i]) - ord('0')
          else HelpUser;
      end { for };
      if not (StickSize in [0..MaxStickSize]) then HelpUser;
      exit; end
    else if ParamCount <> 0 then HelpUser;

    repeat
      write('  㫠 (1..',MaxStickSize,')? ');
      readln(StickSize);
      if StickSize < 0 then writeln( '⥫ 㫨 ﬠ!');
      if StickSize = 0 then writeln( '    㫠,   ﬠ!');
      if MaxStickSize < StickSize then begin
	writeln('४ ﬠ 㫠 (max = ',MaxStickSize,').');
      end { if };
    until (0 < StickSize) and (StickSize <= MaxStickSize);
  end { GetNdisks };

begin { Main Program }
  {$ifdef Color} SetColor(Normal); {$endif}
  Clrscr;
						  {$ifdef Show} {$ifdef Color}
  for i:= 1 to MaxStickSize do DiskClr[i]:= (i mod 6 + 1) * 16;
							     {$endif} {$endif}
  writeln('  ᪨ 㫨.'); writeln;
  GetNdisks;
  MoveCount:= 0;                                 { 㫨ࠬ   室 }
								 {$ifdef Show}
  Start:= 3 + (23 - StickSize - 2) div 2;
  Xoffset:= (MsgLimit -StickSize*3) div 2;
  ClrScr;       {   ࠬ   㢠 砫 . }
  for i:= 0 to 2 do begin {ᢠ 㪢    订 A, B, C}
    GotoXY(Xoffset +StickSize*i +1 +StickSize div 2, Start +StickSize +1);
    write(chr(ord('A') + i));
  end { for };

  GotoXY(1 + Xoffset, Start + StickSize);        { 㢠 砫 䨣 }
  for i:= 1 to StickSize * 3 do write(BaseCh);
  for i:= StickSize downto 1 do begin
    PrepDisk(i); {$ifdef Color} SetColor(DiskClr[i]); {$endif}
    GotoXY(1 + Xoffset + 0*StickSize +(StickSize-i) div 2, Start+i-1);
    write(DiskPic); {$ifdef Color} SetColor(Normal); {$endif}
    GotoXY(1 + Xoffset + 1*StickSize +(StickSize-i) div 2, Start+i-1);
    write(EmptyDisk);
    GotoXY(1 + Xoffset + 2*StickSize +(StickSize-i) div 2, Start+i-1);
    write(EmptyDisk);
  end { for };

  GotoXY(1, 1); writeln('蠢    ᪨ 㫨.');
  Disks[StickA]:= StickSize; Disks[StickB]:=0; Disks[StickC]:=0; {$ifdef info}
  timeX:= msglimit -8; timeY:= Start + 3 + StickSize;
  gotoxy(       1, timeY); writeln('Move No: 0');
  gotoxy(timeX -5, timeY); writeln('time 00:00:00');
  GetTime(Hour, Min, Sec, s100); oldS:= 0;                    {$endif} {$else}

  writeln('襭    ᪨ 㫨.');

  writeln('  㫠 ', StickSize, ' ᪠.');
  writeln('  : ');                                       {$endif}

  MoveDisks(StickSize, StickA, StickC, StickB);
						   {$ifdef Show} {$ifdef info}
  CalcTimeInterval;
  if oldS <> ds then begin
    GotoXY(timeX, timeY);
    write(dH div 10, dH mod 10, ':',
	  dM div 10, dM mod 10, ':',
	  dS div 10, dS mod 10);
    oldS:= dS;
  end { if };                                                         {$endif}
  GotoXY(1, Start + 4 + StickSize);                                   {$endif}
  write('஡  襭  ', MoveCount, ' .');
  goto quit;        { ᪠砬 ਢ  ࠭,   ࠢ  ^C }
exit1:
  {$ifdef Show} clrscr; {$endif}
  writeln('ணࠬ  ४᭠!');
quit:
end { Hanoi }.