{$A+,B-,F-,I-,N-,O-,Q-,R-,S-}

{   -  ࠡ  IBM
	( ꫤ᪨ UniCRT.BDY  UniCRT.SYM) }

unit UniCRT;

	INTERFACE

const
	{  梥: }
  Black		= 0;	{ 	}
  Blue		= 1;	{ 		}
  Green		= 2;	{ 	}
  Cyan		= 3;	{ 㡮	}
  Red		= 4;	{ 	}
  Magenta	= 5;	{ ⮢	}
  Brown		= 6;	{ 筥	}
  LightGray	= 7;	{ મ-	}
	{ ન 梥: }
  DarkGray	= 8;	{ 		}
  LightBlue	= 9;	{ મ-	}
  LightGreen	= 10;	{ ⮢	}
  LightCyan	= 11;	{ મ-㡮	}
  LightRed	= 12;	{ 	}
  LightMagenta	= 13;	{ 	}
  Yellow	= 14;	{ 	}
  White		= 15;	{ 		}
	{   栭: }
  Blink		= 128;
	{ ⮢ ०: }
  BW40		= 0;	{ 40 x 25 ୮-	}
  BW80		= 4;	{ 80 x 25 ୮-	}
  CO40		= 5;	{ 40 x 25 ⭮	}

procedure ActvCrsr(Size : Byte);

procedure PassCrsr(Size : Byte);

function  ScrXSize : Byte;

function  ScrYSize : Byte;

procedure PlayMelody(var Melody);

procedure PlayNote(Note, Tembr : Byte; Length : Word);

procedure ClrScr;

procedure ClrEos;

procedure ClrEol;

procedure Delay(MS : Word);

procedure GoToXY(X, Y : Byte);

function  KeyPressed : Boolean;

function  ReadKey : Char;

procedure SetColor(Attribute : Byte);

function  GetColor : Byte;

procedure TextMode(Mode : Byte);

function  WhereX : Byte;

function  WhereY : Byte;

	IMPLEMENTATION

uses CRT;

procedure ActvCrsr(Size : Byte); assembler;
{  ⥭   Size }
asm
	mov	ah,1
	mov	cx,607h
	int	10h
end;

procedure PassCrsr(Size : Byte); assembler;
{  ⥭   Size }
asm
	mov	ah,1
	mov	ch,20h
	int	10h
end;

function  ScrXSize : Byte; assembler;
asm
	mov	es,Seg0040
	mov	al,es:[$4a]
end;

function  ScrYSize : Byte; assembler;
asm
	mov	al,25
end;

procedure PlayMelody(var Melody);
begin
	{ 楤   }
end;

procedure PlayNote(Note, Tembr : Byte; Length : Word);
{  ᤥ ⥬ }
const f : array [1..12] of Word =
	(330,349,370,392,415,440,466,494,523,554,588,622);
var
  fs : Word;
  okt, ntp : Byte;
begin
  okt:=Note div 12; ntp:=Note mod 12 + 1;
  fs:=Trunc(f[ntp]*Exp((okt-1)*Ln(2)));
  Sound(fs); Delay(Length); NoSound
end;

procedure ClrScr;
begin
  CRT.ClrScr
end;

procedure ClrEos; assembler;
asm
	mov	ah,3
	xor	bh,bh
	int	10h
	push	dx
	mov	bl,7
@x0:	mov	cx,1
	mov	al,20h
	mov	ah,9
	int	10h
	mov	ah,3
	int	10h
	mov	es,Seg0040
	cmp	dl,es:[$4a]
	inc	dl
	mov	ah,2
	jbe	@x1
	xor	dl,dl
	inc	dh
	cmp	dh,25
	je	@x2
@x1:	int	10h
	jmp	@x0
@x2:	pop	dx
	mov	ah,2
	int	10h
end;

procedure ClrEol;
begin
  CRT.ClrEol
end;

procedure Delay(MS : Word);
begin
  CRT.Delay(MS)
end;

procedure GoToXY(X, Y : Byte);
begin
  CRT.GoToXY(X,Y)
end;

function  KeyPressed : Boolean;
begin
  KeyPressed:=CRT.KeyPressed
end;

function  ReadKey : Char;
{ F11/F12 -  ࠡ! }
var
  A : Byte;
  cv, cv1 : Char;
begin
  cv:=CRT.ReadKey;
  case cv of
    #9: A:=237; #13: A:=192;
    #8: A:=127; #127: A:=239;
    #0: begin
      cv1:=CRT.ReadKey;
      case cv1 of
	#3: A:=0; #15: A:=238;
	#71: A:=197; #72: A:=196;
	#73: A:=200; #75: A:=193;
	#77: A:=194; #79: A:=198;
	#80: A:=195; #81: A:=199;
	#82: A:=250; #83: A:=249;
	#115: A:=241; #116: A:=242;
	#117: A:=246; #118: A:=247;
	#119: A:=245; #132: A:=248;
	#59..#68: A:=Ord(cv1)+142;
	#84..#93: A:=Ord(cv1)+129;
	#94..#103: A:=Ord(cv1)+131
      end
    end
    else A:=Ord(cv)
  end;
  ReadKey:=Chr(A)
end;

procedure SetColor(Attribute : Byte);
begin
  TextAttr:=(Attribute and $88) or ((Attribute and $70) shr 4)
    or ((Attribute and $07) shl 4)
end;

function  GetColor : Byte; assembler;
asm
	mov	al,TextAttr
end;

procedure TextMode(Mode : Byte);
begin
  case Mode of
    BW40: CRT.TextMode(CRT.BW40);
    BW80: CRT.TextMode(CRT.BW80);
    CO40: CRT.TextMode(CRT.CO40)
  end
end;

function  WhereX : Byte;
begin
  WhereX:=CRT.WhereX
end;

function  WhereY : Byte;
begin
  WhereY:=CRT.WhereY
end;

end { UniCRT }.